#!/usr/bin/env pybricks-micropython
from pybricks.hubs import EV3Brick
from pybricks.ev3devices import (Motor, TouchSensor, ColorSensor,
                                 InfraredSensor, UltrasonicSensor, GyroSensor)
from pybricks.parameters import Port, Stop, Direction, Button, Color
from pybricks.tools import wait, StopWatch, DataLog
from pybricks.robotics import DriveBase
from pybricks.media.ev3dev import SoundFile, ImageFile


# This program requires LEGO EV3 MicroPython v2.0 or higher.
# Click "Open user guide" on the EV3 extension tab for more information.


# Create your objects here.                                                             


ev3 = EV3Brick()
ev3.speaker.beep()
right_cs = ColorSensor(Port.S3)
left_cs = ColorSensor(Port.S2)
hight_cs = ColorSensor(Port.S1)
Ultra = UltrasonicSensor(Port.S4)
left_motor = Motor( Port.B ,positive_direction=Direction.COUNTERCLOCKWISE, gears=None)
right_motor = Motor( Port.C ,positive_direction=Direction.COUNTERCLOCKWISE, gears=None)
forward_motor = Motor( Port.D ,positive_direction=Direction.COUNTERCLOCKWISE, gears=None)
down_motor = Motor( Port.A ,positive_direction=Direction.COUNTERCLOCKWISE, gears=None)
Drive = DriveBase(left_motor, right_motor, 56,152)
Drive.settings(400, 200, 400, 200)
power = 50

kp = 0.3
r_white= 45
r_black = 7
l_white = 38
l_black = 7
l_k_norm = 100 / (l_white - r_black)
r_k_norm = 100 / (r_white - l_black)
angle = 50

def l_reflection_norm():
    return int((left_cs.reflection() - l_black) * l_k_norm)

def r_reflection_norm():
    return int((right_cs.reflection() - r_black) * r_k_norm)


def prop (power, kp ):
    reg_sign = ((left_cs.reflection() - right_cs.reflection( )) * kp )
    left_motor.dc(power + reg_sign)
    right_motor.dc(power - reg_sign)
    print('let-',left_cs.reflection() ,'right-',right_cs.reflection( ))

def prop_angle(angle, power = power, kp = kp):
    new_angle = left_motor.angle() + angle
    while left_motor.angle() < new_angle:
        prop(power,kp)


def prop_R(power , kp ):                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
    print( " left ", l_reflection_norm(), "right ", r_reflection_norm())
    while not ( l_reflection_norm()> 30 and r_reflection_norm() <15 ):
        prop(power, kp)

def prop_one_R(power , kp ):                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
    print( " left ", l_reflection_norm(), "right ", r_reflection_norm())
    while not ( r_reflection_norm() <15 ):
        reg_sign = ((left_cs.reflection() - 25) * kp )
        left_motor.dc(power + reg_sign)
        right_motor.dc(power - reg_sign)
        print('let-',left_cs.reflection() ,'right-',right_cs.reflection( ))

def prop_L(power, kp) :                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
    print( " left ", l_reflection_norm(), "right ", r_reflection_norm())
    while not (l_reflection_norm() < 30 and r_reflection_norm( ) > 15 ):
        prop(power, kp)

def prop_T(power, kp) :                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
    print( " left ", l_reflection_norm(), "right ", r_reflection_norm())
    while not ((l_reflection_norm() < 40) and (r_reflection_norm() < 40 )):
        print( " left ", l_reflection_norm(), "right ", r_reflection_norm())
        prop(power, kp)

def color():
    if str(hight_cs.color()) == 'Color.RED':
        Drive.straight(-50)
        Drive.stop()
        forward_motor.run_time(1000,450)
        Drive.straight(200)
        Drive.stop()
        forward_motor.run_time(-1000,450)
        Drive.straight(-150)
        Drive.stop()


# for i in range(0,5):это забор
#     Drive.straight(90)
#     Drive.stop()
#     down_motor.run_time(1000,1000)
#     down_motor.run_time(-1000,1000)
# for i in range(0,5):
#     Drive.straight(-90)
#     Drive.stop()
#     down_motor.run_time(-1000,1000)
#     down_motor.run_time(-1000,1000)
# prop_L(power,kp)
# Drive.stop()
# print('no')
# Drive.straight(125)
# print('yes')
# Drive.turn(-90)
# Drive.stop()
# prop_R(power,kp)
# print('no')
# Drive.straight(120)
# print('yes')
# Drive.turn(90)
# Drive.stop()
forward_motor.run_time(1000,1000,then=Stop.HOLD, wait=True)
prop_angle(100,30,0.4)
prop_one_R(50,0.5)
Drive.stop()
# wait(1000)
Drive.straight(30)
Drive.stop()
prop_angle(20,30,0.3) 
Drive.stop()
down_motor.run_time(-300, 1000, then=Stop.HOLD, wait=True)
wait(1000)
forward_motor.run_time(-1000,1000)
wait(1000)
Drive.turn(88) 
wait(1000)
Drive.straight(97)
wait(1000)
Drive.stop()
down_motor.run_time(300, 1000, then=Stop.HOLD, wait=True)
wait(1000)
Drive.straight(-105)
wait(1000)
Drive.turn(-88)
wait(1000)
Drive.straight(-80)
wait(1000)
Drive.stop()
wait(1000)
forward_motor.run_time(1000,600)
Drive.straight(-30)
Drive.stop()

for i in range(0,1):
    prop_one_R(60,0.6)
    print('bce')
    Drive.stop()
    wait(2000)
    down_motor.run_time(-300, 1000, then=Stop.HOLD, wait=True)

    Drive.straight(110)
    forward_motor.run_time(-1000,1000)
    Drive.stop()
    Drive.turn(84)
    Drive.stop()
    Drive.straight(160)
    down_motor.run_time(300, 1000, then=Stop.HOLD, wait=True)
    Drive.stop()
    forward_motor.run_time(1000,1000)
    Drive.straight(-100)
    Drive.stop()
    Drive.turn(-90)
    Drive.straight(-110)
    Drive.stop()





# if Ultra.distance() < 100:
    # forward_motor.reset_angle(0)
    # down_motor.reset_angle(0)
    # print('if')
    # down_motor.run_time(-1000,380)
    # prop_angle(50)
    # prop_R(70,0.2)
    # Drive.straight(120)
    # Drive.stop()
    # Drive.turn(90)
    # Drive.stop()
    # Drive.straight(100)
    # Drive.stop()
    # wait(100)
    # if str(hight_cs.color()) == 'Color.RED':
    #     lamp1 = 'RED'
    # else:
    #     lamp1 ='YELLOW'
    # color()
    # Drive.straight(-90)
    # Drive.stop()
    # Drive.turn(-90)
    # Drive.stop()   
    # prop_angle(20,20,0.2)
    # prop_R(power,kp)#поворот ко 2 лампе
    # Drive.straight(85)
    # Drive.stop()
    # Drive.turn(90)
    # Drive.stop()
    # prop_angle(100, 30, 0.5)
    # Drive.straight(81)
    # Drive.stop()  
    # if str(hight_cs.color()) == 'Color.RED':
    #     lamp2 = 'RED'
    # else:
    #     lamp2 ='YELLOW' 
    # color()
    # Drive.straight(-160)
    # Drive.stop()
    # Drive.turn(-90)
    # Drive.stop() 
    # Drive.straight(-60)
    # Drive.stop()
    # prop_angle(20, 20, 0.2)
    # prop_L(30,0.1)
    # Drive.straight(80)
    # Drive.stop()
    # Drive.turn(-90)
    # Drive.stop()
    # Drive.straight(90)
    # Drive.stop()    
    # wait(100)
    # if str(hight_cs.color()) == 'Color.RED':
    #     lamp3 = 'RED'
    # else:
    #     lamp3 ='YELLOW'
    # color()    
    # Drive.straight(-90)
    # Drive.stop()
    # Drive.turn(90)
    # Drive.stop()  
    # prop_angle(20, 20, 0.5)
    # prop_R(80,0.2)
    # Drive.straight(90)
    # Drive.stop()
    # Drive.turn(90)
    # Drive.stop()
    # Drive.straight(100)
    # Drive.stop()
    # wait(100)
    # if str(hight_cs.color()) == 'Color.RED':
    #     lamp4 = 'RED'
    # else:
    #     lamp4 ='YELLOW'
    # color()
    # Drive.straight(-100)
    # Drive.stop()
    # Drive.turn(-90)
    # Drive.stop()   
    # prop_angle(300,50,0.2)
    # prop_L(30,0.1)
    # Drive.straight(90)
    # Drive.stop()
    # Drive.turn(-90)
    # Drive.stop()
    # Drive.straight(190)
    # Drive.stop()  
    # if str(hight_cs.color()) == 'Color.RED':
    #     lamp5 = 'RED'
    # else:
    #     lamp5 ='YELLOW' 
    # color()
    # Drive.straight(-190)
    # Drive.stop()
    # Drive.turn(90)
    # Drive.stop() 
    # prop_R(power,kp)#поворот ко 2 лампе
    # Drive.straight(85)
    # Drive.stop()
    # Drive.turn(90)
    # Drive.stop() 
    # prop_angle(100, 30, 0.5)
    # Drive.straight(60)
    # Drive.stop()  
    # if str(hight_cs.color()) == 'Color.RED':
    #     lamp6 = 'RED'
    # else:
    #     lamp6 ='YELLOW'
    # color()
    # Drive.straight(-130)
    # Drive.stop()
    # Drive.turn(-90)
    # Drive.stop() 
    # prop_T(power,kp)
    # Drive.straight(90)
    # Drive.stop()
    # Drive.turn(90)
    # Drive.stop()
    # prop_angle(200,50,0.2)